package com.sonydadc.boxi.javatool;

import java.io.*;
import com.crystaldecisions.sdk.exception.SDKException;
import com.crystaldecisions.sdk.framework.CrystalEnterprise;
import com.crystaldecisions.sdk.framework.IEnterpriseSession;
import com.crystaldecisions.sdk.framework.ISessionMgr;
import com.crystaldecisions.sdk.occa.infostore.*;
import com.crystaldecisions.sdk.plugin.destination.smtp.ISMTPOptions;
import com.crystaldecisions.sdk.properties.IProperties;
import com.crystaldecisions.sdk.properties.IProperty;

/*
 *  tool for extraction scheduled reports with email destination
 */

public class program {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		IEnterpriseSession enterpriseSession = null;
		Integer a = 0;
		try {
			File fos = new File("C:/temp/recurring_emails.csv");
			FileWriter fosw = new FileWriter(fos);

			System.out.println("Connecting...");
			ISessionMgr sessionMgr = CrystalEnterprise.getSessionMgr();
			enterpriseSession = sessionMgr.logon("Administrator", "<password>", "<serverhostmame:cmsport>", "secEnterprise");

			// System.out.println("Connected");
			IInfoStore infoStore = (IInfoStore) enterpriseSession.getService("InfoStore");
			String query = "select TOP 6000 * from CI_INFOOBJECTS where SI_RECURRING=1 and si_instance=1 and SI_SCHEDULE_STATUS=9 AND SI_SENDABLE = 1";

			// System.out.println("Select..");
			IInfoObjects infoObjects = (IInfoObjects) infoStore.query(query);

			for (Object object : infoObjects) {
				IInfoObject infoObject = (IInfoObject) object;
				ISchedulingInfo scheduleInfo = infoObject.getSchedulingInfo();
				IDestination destination = scheduleInfo.getDestination();

				IProperties instanceProperties = (IProperties) infoObject.properties();
				IProperty instancePropertyNR = instanceProperties.getProperty("SI_NEXTRUNTIME");
				String nextruntime = "";
				if(instancePropertyNR != null) {
					nextruntime = instancePropertyNR.getValue().toString();
				};

    			String owner = "";
    			owner = infoObject.properties().getProperty("SI_OWNER").toString();

				String nrtim = "";
    			if (scheduleInfo.properties().getProperty("SI_NEXTRUNTIME") != null) {
    				nrtim = infoObject.properties().getProperty("SI_NEXTRUNTIME").toString();
    			}				
					  
				IDestinationPlugin destPlugin = (IDestinationPlugin) infoStore.query("select * from ci_systemobjects where si_parentId=29 and si_name='CrystalEnterprise.Smtp' ").get(0);

				if (destination.properties().getProperty("SI_PROGID") != null) {
					if (destination.properties().getProperty("SI_PROGID").toString().equals("CrystalEnterprise.Smtp")) {
						destination.copyToPlugin(destPlugin); 																	// tady to blbne
						if (destPlugin == null) {
							System.out.println("Unable to get DestPlugin");
						} else {
							ISMTPOptions smtpOptions = (ISMTPOptions) destPlugin.getScheduleOptions();
							String path 	= "";
							String title 	= "";
							String sender 	= "";
							String subj 	= "";
							String dest 	= "";
							String cc 		= "";
							
							path 	= getInfoObjectPath(infoObject);
							title 	= infoObject.getTitle();
							subj    = smtpOptions.getSubject();
							sender 	= smtpOptions.getSenderAddress();
							dest 	= smtpOptions.getToAddresses().toString();
							cc 		= smtpOptions.getCCAddresses().toString();

							if (sender != null) {
								fosw.write(path + ";" + title + ";" + subj + ";" + sender + ";" + dest + ";" + cc + ";"+nextruntime+ ";" + nrtim +";" + owner + "\n");

								if ((a % 100) == 0) {
									System.out.println(a);
								}
								; // status by 100
								a = a + 1;
							} else {
								fosw.write(path + ";\n");
							}
						}
					}
				}
			} // end for

			fosw.close();
		}

		catch (SDKException ex) {
			ex.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if (enterpriseSession != null)
				enterpriseSession.logoff();
		}
		System.out.println("Finished!");
	}

	public static String getInfoObjectPath(IInfoObject infoObject) throws SDKException {
		String path = "";
		while (infoObject.getParentID() != 0) {
			infoObject = infoObject.getParent();
			path = "/" + infoObject.getTitle() + path;
		}
		return path;
	}
}
